/***************************************************************************
                          audioeng_buff.cpp  -  description

  	That is a derivated class to handle generically buffered input/output
	
                             -------------------
    begin                : Thu Feb 7 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//#include <stream.h>
#include <assert.h>
#include <math.h>

#include "config.h"
#include "avifmt.h"
#include "avifmt2.h"
#include "avio.hxx"
#include "fourcc.h"
//#include "aviaudio.hxx"
#include "audioprocess.hxx"
//#include "../toolkit.hxx"
//
AVDMBufferedAudioStream::AVDMBufferedAudioStream(AVDMGenericAudioStream * instream):AVDMProcessAudioStream
    (instream)
{

    _bufferlen = 0;
}

//
//
uint32_t AVDMBufferedAudioStream::read(uint32_t len, uint8_t * buffer)
{
    uint32_t avail = 0;
    // this disable the filter
    // return _instream->read(len,buffer);

  more:
    //      printf("\n asked : %lu, available : %lu",len,_bufferlen);                               

    // have we already got what's needed ?
    if (_bufferlen >= len)
      {
	drain:
	  memcpy(buffer + avail, _buffer, len);
	  //   memmove(_buffer,_buffer+len,_bufferlen-len);
//___overlapping causes problems_________
#warning FIXME : Workaround
	  uint8_t *des, *src;
	  des = (uint8_t *) (_buffer);
	  src = des + len;
	  for (uint32_t y = (_bufferlen - len); y > 0; y--)
	      *des++ = *src++;
	  _bufferlen -= len;
	  avail += len;
	  return avail;
      }
    // first empty what was available
    memcpy(buffer + avail, _buffer, _bufferlen);
    avail += _bufferlen;
    len -= _bufferlen;
    // ask for more to the previous stream
    _bufferlen = 0;
    //printf("\n grabing...");
    _bufferlen = grab((uint8_t *) _buffer);
    // This also disable the filter but at a lower level                                                    
    //      printf(" got %lu...\n",_bufferlen);
    if (_bufferlen == MINUS_ONE)
      {
	  printf("\n end stream \n");
	  _bufferlen = 0;
	  return avail;		// we got everything  !
      }
    // check if we reach dangerous level
    if (_bufferlen >= (PROCESS_BUFFER_SIZE * 2 / 3))
      {
	  printf("\n drain \n");
	  goto drain;
      }
    goto more;
};

// EOF
