/*
 * DO NOT EDIT THIS FILE - it is generated by Glade.
 */

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "config.h"
#include "ADM_gui2/support.h"
#include "ADM_library/default.h"
#include "ADM_toolkit/toolkit.hxx"
//___________________________________
#include "avi_vars.h"
#include "ADM_video/ADM_genvideo.hxx"
#include "ADM_encoder/ADM_vidEncode.hxx"
#include "ADM_encoder/adm_encoder.h"
#include "ADM_toolkit/toolkit_gtk.h"
#include "ADM_toolkit/filesel.h"
//___________________________________
#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)

#define RADIO_SET(widget_name,value) gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON (lookup_widget(dialog,#widget_name)), value)

static GtkWidget	*create_dialog1 (void);
static void on_callback_index(GtkButton * button, gpointer user_data);
static void on_callback_mpeg(GtkButton * button, gpointer user_data);
static void on_callback_scan(GtkButton * button, gpointer user_data);

extern uint8_t  MpegaudoDetectAudio(char *name, uint8_t *audioTrack);

void mpegCB(char *name);
void indexCB(char *name);

static char _indexName[300];
static char _mpegName[300];
static GtkWidget *dialog;
/**
	Prefill the index name & mpeg name with given string.
	Used to automatically index a prompted video

*/

void DIA_indexerPrefill(char *name)
{
		char tmp[500];
				strcpy(_mpegName,name);
				strcpy(tmp,name);
				strcat(tmp,".idx");
				strcpy(_indexName,tmp);

}
/**
	DiampegIndexer :
				mpegFile returns a pointer to the mpeg to index 's name
				indexFile rreturns a pointer to index name
				aid : audio id (C0--C7 for mpeg, 0--7 for AC3)
				already : if set to 1, use the prefilled entries

*/
int  DIA_mpegIndexer(char **mpegFile,char **indexFile,int *aid,int already)
{
uint8_t ret=0;


	dialog=create_dialog1();

	if(already)
	{
		gtk_label_set_text(GTK_LABEL(lookup_widget(dialog,"label_index")),_indexName);
		gtk_label_set_text(GTK_LABEL(lookup_widget(dialog,"labelmpeg")),_mpegName);

	}

	#define CONNECT(A,B)  gtk_signal_connect (GTK_OBJECT(lookup_widget(dialog,#A)), "clicked", \
		      GTK_SIGNAL_FUNC (B), (void *) NULL);

	CONNECT(button_mpeg,on_callback_mpeg);
	CONNECT(button_index,on_callback_index);
	CONNECT(button_scan,on_callback_scan);

	if(gtk_dialog_run(GTK_DIALOG(dialog))==GTK_RESPONSE_OK)
	{
			*indexFile=_indexName;
			*mpegFile=_mpegName;
			// now grab AC3/mpeg ?
			*aid=0;
			if(TRUE==gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON
									  (lookup_widget(dialog,"radiobutton_mpeg"))))
									  *aid+=0xC0;
			if(TRUE==gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON
									  (lookup_widget(dialog,"radiobutton1"))))
									  *aid+=0xA0;

			*aid+=getRangeInMenu(lookup_widget(dialog,"optionmenu1"));

			ret=1;

	}

	gtk_widget_destroy(dialog);

	return ret;
}

//--------------------------------------------------------------------------------------------
void on_callback_index(GtkButton * button, gpointer user_data)
{
        UNUSED_ARG(button);
    	UNUSED_ARG(user_data);
        GUI_FileSelWrite("Index to create", indexCB)  ;
}
void indexCB(char *name)
{
	strcpy(_indexName,name);
	 gtk_label_set_text(GTK_LABEL(lookup_widget(dialog,"label_index")),name);
}
void on_callback_mpeg(GtkButton * button, gpointer user_data)
{
    	UNUSED_ARG(button);
   	UNUSED_ARG(user_data);
    	GUI_FileSelRead("Mpeg to scan", mpegCB)           ;

}

void on_callback_scan(GtkButton * button, gpointer user_data)
{
	uint8_t track;

    	UNUSED_ARG(button);
   	UNUSED_ARG(user_data);

	if(MpegaudoDetectAudio(_mpegName,&track))
	{
		printf("detected audio :%x\n",track);
		switch(track)
			{
				case 0:
						RADIO_SET(radiobutton_ac3,1);
						break;
				case 0xC0:
						RADIO_SET(radiobutton_mpeg,1);
						break;
				case 0xA0:
						RADIO_SET(radiobutton1,1);
						break;
				default:assert(0);

			}

	}
	else
		GUI_Alert("Could no identift audio stream");
}


void mpegCB(char *name)
{
	strcpy(_mpegName,name);
	 gtk_label_set_text(GTK_LABEL(lookup_widget(dialog,"labelmpeg")),name);
}
#if 0
GtkWidget	*create_dialog1 (void)
{
  GtkWidget *dialog1;
  GtkWidget *dialog_vbox1;
  GtkWidget *vbox1;
  GtkWidget *hbox2;
  GtkWidget *labelmpeg;
  GtkWidget *button_mpeg;
  GtkWidget *hbox3;
  GtkWidget *label_index;
  GtkWidget *button_index;
  GtkWidget *hbox1;
  GtkWidget *vbox2;
  GtkWidget *radiobutton_mpeg;
  GSList *radiobutton_mpeg_group = NULL;
  GtkWidget *radiobutton_ac3;
  GtkWidget *radiobutton1;
  GtkWidget *optionmenu1;
  GtkWidget *menu1;
  GtkWidget *item0;
  GtkWidget *item1;
  GtkWidget *item2;
  GtkWidget *item3;
  GtkWidget *item4;
  GtkWidget *item5;
  GtkWidget *item6;
  GtkWidget *item7;
  GtkWidget *dialog_action_area1;
  GtkWidget *cancelbutton1;
  GtkWidget *okbutton1;

  dialog1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog1), _("Mpeg Indexer"));

  dialog_vbox1 = GTK_DIALOG (dialog1)->vbox;
  gtk_widget_show (dialog_vbox1);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), vbox1, TRUE, TRUE, 0);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, TRUE, TRUE, 0);

  labelmpeg = gtk_label_new ("");
  gtk_widget_show (labelmpeg);
  gtk_box_pack_start (GTK_BOX (hbox2), labelmpeg, TRUE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (labelmpeg), GTK_JUSTIFY_LEFT);

  button_mpeg = gtk_button_new_with_mnemonic (_("Select Mpeg"));
  gtk_widget_show (button_mpeg);
  gtk_box_pack_start (GTK_BOX (hbox2), button_mpeg, FALSE, FALSE, 0);

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox3, TRUE, TRUE, 0);

  label_index = gtk_label_new ("");
  gtk_widget_show (label_index);
  gtk_box_pack_start (GTK_BOX (hbox3), label_index, TRUE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label_index), GTK_JUSTIFY_LEFT);

  button_index = gtk_button_new_with_mnemonic (_("Select Index"));
  gtk_widget_show (button_index);
  gtk_box_pack_start (GTK_BOX (hbox3), button_index, FALSE, FALSE, 0);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox2);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox2, TRUE, TRUE, 0);

  radiobutton_mpeg = gtk_radio_button_new_with_mnemonic (NULL, _("Mpeg audio"));
  gtk_widget_show (radiobutton_mpeg);
  gtk_box_pack_start (GTK_BOX (vbox2), radiobutton_mpeg, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_mpeg), radiobutton_mpeg_group);
  radiobutton_mpeg_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_mpeg));

  radiobutton_ac3 = gtk_radio_button_new_with_mnemonic (NULL, _("AC3 audio"));
  gtk_widget_show (radiobutton_ac3);
  gtk_box_pack_start (GTK_BOX (vbox2), radiobutton_ac3, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_ac3), radiobutton_mpeg_group);
  radiobutton_mpeg_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_ac3));
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton_ac3), TRUE);

  radiobutton1 = gtk_radio_button_new_with_mnemonic (NULL, _("LPCM"));
  gtk_widget_show (radiobutton1);
  gtk_box_pack_start (GTK_BOX (vbox2), radiobutton1, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton1), radiobutton_mpeg_group);
  radiobutton_mpeg_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton1));

  optionmenu1 = gtk_option_menu_new ();
  gtk_widget_show (optionmenu1);
  gtk_box_pack_start (GTK_BOX (hbox1), optionmenu1, TRUE, FALSE, 0);

  menu1 = gtk_menu_new ();

  item0 = gtk_menu_item_new_with_mnemonic (_("0"));
  gtk_widget_show (item0);
  gtk_container_add (GTK_CONTAINER (menu1), item0);

  item1 = gtk_menu_item_new_with_mnemonic (_("1"));
  gtk_widget_show (item1);
  gtk_container_add (GTK_CONTAINER (menu1), item1);

  item2 = gtk_menu_item_new_with_mnemonic (_("2"));
  gtk_widget_show (item2);
  gtk_container_add (GTK_CONTAINER (menu1), item2);

  item3 = gtk_menu_item_new_with_mnemonic (_("3"));
  gtk_widget_show (item3);
  gtk_container_add (GTK_CONTAINER (menu1), item3);

  item4 = gtk_menu_item_new_with_mnemonic (_("4"));
  gtk_widget_show (item4);
  gtk_container_add (GTK_CONTAINER (menu1), item4);

  item5 = gtk_menu_item_new_with_mnemonic (_("5"));
  gtk_widget_show (item5);
  gtk_container_add (GTK_CONTAINER (menu1), item5);

  item6 = gtk_menu_item_new_with_mnemonic (_("6"));
  gtk_widget_show (item6);
  gtk_container_add (GTK_CONTAINER (menu1), item6);

  item7 = gtk_menu_item_new_with_mnemonic (_("7"));
  gtk_widget_show (item7);
  gtk_container_add (GTK_CONTAINER (menu1), item7);

  gtk_option_menu_set_menu (GTK_OPTION_MENU (optionmenu1), menu1);

  dialog_action_area1 = GTK_DIALOG (dialog1)->action_area;
  gtk_widget_show (dialog_action_area1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);

  cancelbutton1 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (cancelbutton1);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), cancelbutton1, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (cancelbutton1, GTK_CAN_DEFAULT);

  okbutton1 = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (okbutton1);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), okbutton1, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (okbutton1, GTK_CAN_DEFAULT);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (dialog1, dialog1, "dialog1");
  GLADE_HOOKUP_OBJECT_NO_REF (dialog1, dialog_vbox1, "dialog_vbox1");
  GLADE_HOOKUP_OBJECT (dialog1, vbox1, "vbox1");
  GLADE_HOOKUP_OBJECT (dialog1, hbox2, "hbox2");
  GLADE_HOOKUP_OBJECT (dialog1, labelmpeg, "labelmpeg");
  GLADE_HOOKUP_OBJECT (dialog1, button_mpeg, "button_mpeg");
  GLADE_HOOKUP_OBJECT (dialog1, hbox3, "hbox3");
  GLADE_HOOKUP_OBJECT (dialog1, label_index, "label_index");
  GLADE_HOOKUP_OBJECT (dialog1, button_index, "button_index");
  GLADE_HOOKUP_OBJECT (dialog1, hbox1, "hbox1");
  GLADE_HOOKUP_OBJECT (dialog1, vbox2, "vbox2");
  GLADE_HOOKUP_OBJECT (dialog1, radiobutton_mpeg, "radiobutton_mpeg");
  GLADE_HOOKUP_OBJECT (dialog1, radiobutton_ac3, "radiobutton_ac3");
  GLADE_HOOKUP_OBJECT (dialog1, radiobutton1, "radiobutton1");
  GLADE_HOOKUP_OBJECT (dialog1, optionmenu1, "optionmenu1");
  GLADE_HOOKUP_OBJECT (dialog1, menu1, "menu1");
  GLADE_HOOKUP_OBJECT (dialog1, item0, "item0");
  GLADE_HOOKUP_OBJECT (dialog1, item1, "item1");
  GLADE_HOOKUP_OBJECT (dialog1, item2, "item2");
  GLADE_HOOKUP_OBJECT (dialog1, item3, "item3");
  GLADE_HOOKUP_OBJECT (dialog1, item4, "item4");
  GLADE_HOOKUP_OBJECT (dialog1, item5, "item5");
  GLADE_HOOKUP_OBJECT (dialog1, item6, "item6");
  GLADE_HOOKUP_OBJECT (dialog1, item7, "item7");
  GLADE_HOOKUP_OBJECT_NO_REF (dialog1, dialog_action_area1, "dialog_action_area1");
  GLADE_HOOKUP_OBJECT (dialog1, cancelbutton1, "cancelbutton1");
  GLADE_HOOKUP_OBJECT (dialog1, okbutton1, "okbutton1");

  return dialog1;
}
#endif

GtkWidget*
create_dialog1 (void)
{
  GtkWidget *dialog1;
  GtkWidget *dialog_vbox1;
  GtkWidget *vbox1;
  GtkWidget *hbox2;
  GtkWidget *labelmpeg;
  GtkWidget *button_mpeg;
  GtkWidget *hbox3;
  GtkWidget *label_index;
  GtkWidget *button_index;
  GtkWidget *hbox1;
  GtkWidget *vbox2;
  GtkWidget *radiobutton_mpeg;
  GSList *radiobutton_mpeg_group = NULL;
  GtkWidget *radiobutton_ac3;
  GtkWidget *radiobutton1;
  GtkWidget *optionmenu1;
  GtkWidget *menu1;
  GtkWidget *item0;
  GtkWidget *item1;
  GtkWidget *item2;
  GtkWidget *item3;
  GtkWidget *item4;
  GtkWidget *item5;
  GtkWidget *item6;
  GtkWidget *item7;
  GtkWidget *button_scan;
  GtkWidget *dialog_action_area1;
  GtkWidget *cancelbutton1;
  GtkWidget *okbutton1;

  dialog1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog1), _("Mpeg Indexer"));

  dialog_vbox1 = GTK_DIALOG (dialog1)->vbox;
  gtk_widget_show (dialog_vbox1);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), vbox1, TRUE, TRUE, 0);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, TRUE, TRUE, 0);

  labelmpeg = gtk_label_new ("");
  gtk_widget_show (labelmpeg);
  gtk_box_pack_start (GTK_BOX (hbox2), labelmpeg, TRUE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (labelmpeg), GTK_JUSTIFY_LEFT);

  button_mpeg = gtk_button_new_with_mnemonic (_("Select Mpeg"));
  gtk_widget_show (button_mpeg);
  gtk_box_pack_start (GTK_BOX (hbox2), button_mpeg, FALSE, FALSE, 0);

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox3, TRUE, TRUE, 0);

  label_index = gtk_label_new ("");
  gtk_widget_show (label_index);
  gtk_box_pack_start (GTK_BOX (hbox3), label_index, TRUE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label_index), GTK_JUSTIFY_LEFT);

  button_index = gtk_button_new_with_mnemonic (_("Select Index"));
  gtk_widget_show (button_index);
  gtk_box_pack_start (GTK_BOX (hbox3), button_index, FALSE, FALSE, 0);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox2);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox2, TRUE, TRUE, 0);

  radiobutton_mpeg = gtk_radio_button_new_with_mnemonic (NULL, _("Mpeg audio"));
  gtk_widget_show (radiobutton_mpeg);
  gtk_box_pack_start (GTK_BOX (vbox2), radiobutton_mpeg, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_mpeg), radiobutton_mpeg_group);
  radiobutton_mpeg_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_mpeg));

  radiobutton_ac3 = gtk_radio_button_new_with_mnemonic (NULL, _("AC3 audio"));
  gtk_widget_show (radiobutton_ac3);
  gtk_box_pack_start (GTK_BOX (vbox2), radiobutton_ac3, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_ac3), radiobutton_mpeg_group);
  radiobutton_mpeg_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_ac3));
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton_ac3), TRUE);

  radiobutton1 = gtk_radio_button_new_with_mnemonic (NULL, _("LPCM"));
  gtk_widget_show (radiobutton1);
  gtk_box_pack_start (GTK_BOX (vbox2), radiobutton1, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton1), radiobutton_mpeg_group);
  radiobutton_mpeg_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton1));

  optionmenu1 = gtk_option_menu_new ();
  gtk_widget_show (optionmenu1);
  gtk_box_pack_start (GTK_BOX (hbox1), optionmenu1, TRUE, FALSE, 0);

  menu1 = gtk_menu_new ();

  item0 = gtk_menu_item_new_with_mnemonic (_("0"));
  gtk_widget_show (item0);
  gtk_container_add (GTK_CONTAINER (menu1), item0);

  item1 = gtk_menu_item_new_with_mnemonic (_("1"));
  gtk_widget_show (item1);
  gtk_container_add (GTK_CONTAINER (menu1), item1);

  item2 = gtk_menu_item_new_with_mnemonic (_("2"));
  gtk_widget_show (item2);
  gtk_container_add (GTK_CONTAINER (menu1), item2);

  item3 = gtk_menu_item_new_with_mnemonic (_("3"));
  gtk_widget_show (item3);
  gtk_container_add (GTK_CONTAINER (menu1), item3);

  item4 = gtk_menu_item_new_with_mnemonic (_("4"));
  gtk_widget_show (item4);
  gtk_container_add (GTK_CONTAINER (menu1), item4);

  item5 = gtk_menu_item_new_with_mnemonic (_("5"));
  gtk_widget_show (item5);
  gtk_container_add (GTK_CONTAINER (menu1), item5);

  item6 = gtk_menu_item_new_with_mnemonic (_("6"));
  gtk_widget_show (item6);
  gtk_container_add (GTK_CONTAINER (menu1), item6);

  item7 = gtk_menu_item_new_with_mnemonic (_("7"));
  gtk_widget_show (item7);
  gtk_container_add (GTK_CONTAINER (menu1), item7);

  gtk_option_menu_set_menu (GTK_OPTION_MENU (optionmenu1), menu1);

  button_scan = gtk_button_new_with_mnemonic (_("Scan file for audio stream"));
  gtk_widget_show (button_scan);
  gtk_box_pack_start (GTK_BOX (vbox1), button_scan, FALSE, FALSE, 0);

  dialog_action_area1 = GTK_DIALOG (dialog1)->action_area;
  gtk_widget_show (dialog_action_area1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);

  cancelbutton1 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (cancelbutton1);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), cancelbutton1, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (cancelbutton1, GTK_CAN_DEFAULT);

  okbutton1 = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (okbutton1);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), okbutton1, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (okbutton1, GTK_CAN_DEFAULT);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (dialog1, dialog1, "dialog1");
  GLADE_HOOKUP_OBJECT_NO_REF (dialog1, dialog_vbox1, "dialog_vbox1");
  GLADE_HOOKUP_OBJECT (dialog1, vbox1, "vbox1");
  GLADE_HOOKUP_OBJECT (dialog1, hbox2, "hbox2");
  GLADE_HOOKUP_OBJECT (dialog1, labelmpeg, "labelmpeg");
  GLADE_HOOKUP_OBJECT (dialog1, button_mpeg, "button_mpeg");
  GLADE_HOOKUP_OBJECT (dialog1, hbox3, "hbox3");
  GLADE_HOOKUP_OBJECT (dialog1, label_index, "label_index");
  GLADE_HOOKUP_OBJECT (dialog1, button_index, "button_index");
  GLADE_HOOKUP_OBJECT (dialog1, hbox1, "hbox1");
  GLADE_HOOKUP_OBJECT (dialog1, vbox2, "vbox2");
  GLADE_HOOKUP_OBJECT (dialog1, radiobutton_mpeg, "radiobutton_mpeg");
  GLADE_HOOKUP_OBJECT (dialog1, radiobutton_ac3, "radiobutton_ac3");
  GLADE_HOOKUP_OBJECT (dialog1, radiobutton1, "radiobutton1");
  GLADE_HOOKUP_OBJECT (dialog1, optionmenu1, "optionmenu1");
  GLADE_HOOKUP_OBJECT (dialog1, menu1, "menu1");
  GLADE_HOOKUP_OBJECT (dialog1, item0, "item0");
  GLADE_HOOKUP_OBJECT (dialog1, item1, "item1");
  GLADE_HOOKUP_OBJECT (dialog1, item2, "item2");
  GLADE_HOOKUP_OBJECT (dialog1, item3, "item3");
  GLADE_HOOKUP_OBJECT (dialog1, item4, "item4");
  GLADE_HOOKUP_OBJECT (dialog1, item5, "item5");
  GLADE_HOOKUP_OBJECT (dialog1, item6, "item6");
  GLADE_HOOKUP_OBJECT (dialog1, item7, "item7");
  GLADE_HOOKUP_OBJECT (dialog1, button_scan, "button_scan");
  GLADE_HOOKUP_OBJECT_NO_REF (dialog1, dialog_action_area1, "dialog_action_area1");
  GLADE_HOOKUP_OBJECT (dialog1, cancelbutton1, "cancelbutton1");
  GLADE_HOOKUP_OBJECT (dialog1, okbutton1, "okbutton1");

  return dialog1;
}



