/***************************************************************************
                          GUI_lavEncoder.cpp  -  description
                             -------------------
    begin                : Tue Sep 10 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <config.h>
#include "ADM_lavcodec.h"

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include <config.h>
#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include <assert.h>
#include <math.h>

#include "ADM_library/default.h"
#include "ADM_toolkit/toolkit.hxx"
#include "ADM_encoder/ADM_vidEncode.hxx"


#include "ADM_codecs/ADM_ffmpegConfig.h"
#include "ADM_toolkit/toolkit.hxx"
#ifdef USE_FFMPEG



extern uint8_t getRangeInMenu(GtkWidget *w);

int getFFCompressParams(COMPRESSION_MODE * mode, uint32_t * qz,
		      uint32_t * br,uint32_t *fsize,FFcodecSetting *conf);

static void gui_ok(GtkButton * button, gpointer user_data);
//static void gui_del(GtkButton * button, gpointer user_data);

static GtkWidget *create_ffCompression (void);
static FFcodecSetting *localconf;
static int compresslock;
//static GtkWidget *compress_button_ok;
static GtkWidget *radiobutton1;
static GtkWidget *radiobutton2;
static GtkWidget *radiobutton3;
static GtkWidget *entry_qz;
static GtkWidget *entry_bitrate;
static GtkWidget *entry_size;

static GtkWidget *togglebutton_qpel;
static GtkWidget *togglebutton_4mv;
static GtkWidget *togglebutton_GMC;
static GtkWidget *togglebutton_HQ;
static GtkWidget *togglebutton_TREILLIS;
static GtkWidget *togglebutton_bframe;


static   GtkWidget *spinbutton_startstart;
static   GtkWidget *spinbutton_startend;
static   GtkWidget *spinbutton_cred_rate;
static   GtkWidget *spinbutton_endstart;
static   GtkWidget *spinbutton_endend;  

static   GtkWidget *spinbutton_max_qdiff;
static   GtkWidget *spinbutton_qcompress;
static   GtkWidget *spinbutton_qblur;
static   GtkWidget *spinbutton_lumi_masking;
static   GtkWidget *spinbutton_dark_masking;
static   GtkWidget *spinbutton_luma_elim_threshold;
static   GtkWidget *spinbutton_chroma_elim_threshold;
static   GtkWidget *spinbutton_imin;
static   GtkWidget *spinbutton_imax;

static GtkWidget *optionmenu_quant;
static GtkWidget *optionmenuME;
static Motion_Est_ID ME[6]=
{
    ME_ZERO ,
    ME_FULL,
    ME_LOG,
    ME_PHODS,
    ME_EPZS,
    ME_X1

};
  

static void set( void );
static void get( void );

void get(void )
{

#define CHECKBOX(x,y) if(TRUE==gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(x)))  \
			localconf->y=1; else localconf->y=0;

			CHECKBOX(togglebutton_qpel	,_QPEL);
			CHECKBOX(togglebutton_HQ	,_HQ);
			CHECKBOX(togglebutton_4mv	,_4MV);
			CHECKBOX(togglebutton_GMC	,_GMC);			
			CHECKBOX(togglebutton_bframe	,max_b_frames);
			CHECKBOX(togglebutton_TREILLIS	,_TRELLIS_QUANT);
			
			
			
#undef CHECKBOX									
#define CHECKSPINI(x,y) localconf->y= gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(x)) ; \
		printf(#y" :%d\n",localconf->y);
#define CHECKSPINF(x,y) localconf->y= gtk_spin_button_get_value_as_float(GTK_SPIN_BUTTON(x)) ; \
		printf(#y" :%f\n",localconf->y);		
          		CHECKSPINI( spinbutton_imax,qmax);
          		CHECKSPINI( spinbutton_imin,qmin);
		        CHECKSPINI( spinbutton_max_qdiff,max_qdiff);
          		CHECKSPINF( spinbutton_qcompress,qcompress);
          		CHECKSPINF(spinbutton_qblur,qblur);
          		CHECKSPINF(spinbutton_lumi_masking,lumi_masking);
          		CHECKSPINF(spinbutton_dark_masking,dark_masking);
          		CHECKSPINI(spinbutton_luma_elim_threshold,luma_elim_threshold);
          		CHECKSPINI(spinbutton_chroma_elim_threshold,chroma_elim_threshold);          		
#undef CHECKSPINI
#undef CHECKSPINF
			localconf->me_method=ME[getRangeInMenu(optionmenuME)];
			printf("Me    : %d\n",localconf->me_method);
			localconf->mpeg_quant=getRangeInMenu(optionmenu_quant);
			printf("MpegQ : %d\n",localconf->mpeg_quant);
			

}
void set(void )
{
#define CHECKBOX(x,y) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(x),localconf->y) 

			CHECKBOX(togglebutton_qpel	,_QPEL);
			CHECKBOX(togglebutton_HQ	,_HQ);
			CHECKBOX(togglebutton_4mv	,_4MV);
			CHECKBOX(togglebutton_GMC	,_GMC);			
			CHECKBOX(togglebutton_bframe	,max_b_frames);
			CHECKBOX(togglebutton_TREILLIS	,_TRELLIS_QUANT);
			
#undef CHECKBOX									
#define CHECKSPINI(x,y) gtk_spin_button_set_value(GTK_SPIN_BUTTON(x),(float)localconf->y) ; 
#define CHECKSPINF(x,y) CHECKSPINI(x,y)		
          		CHECKSPINI( spinbutton_imax,qmax);
          		CHECKSPINI( spinbutton_imin,qmin);
		        CHECKSPINI( spinbutton_max_qdiff,max_qdiff);
          		CHECKSPINF( spinbutton_qcompress,qcompress);
          		CHECKSPINF(spinbutton_qblur,qblur);
          		CHECKSPINF(spinbutton_lumi_masking,lumi_masking);
          		CHECKSPINF(spinbutton_dark_masking,dark_masking);
          		CHECKSPINI(spinbutton_luma_elim_threshold,luma_elim_threshold);
          		CHECKSPINI(spinbutton_chroma_elim_threshold,chroma_elim_threshold);

          		
#undef CHECKSPINI
#undef CHECKSPINF
 	gtk_option_menu_set_history (GTK_OPTION_MENU (optionmenu_quant),localconf->mpeg_quant);
	for(int j=0;j<6;j++)
		if(ME[j]==localconf->me_method) 
			gtk_option_menu_set_history (GTK_OPTION_MENU (optionmenuME),j);

}

/*
void gui_del(GtkButton * button, gpointer user_data)
{
    UNUSED_ARG(button);
    UNUSED_ARG(user_data);
    gui_ok(NULL, (gpointer) -1);
}
*/

void gui_ok(GtkButton * button, gpointer user_data)
{
    UNUSED_ARG(button);
    int res;

    res = (int) user_data;
    if (compresslock)
	return;			// second call back->ignore.
    switch (res)
      {
      case 1:
	  compresslock = 1;
	  //gtk_hide_widget(wdg);

	  break;
      case 0:
	  compresslock = -1;
	  break;
      case -1:
     	compresslock=-2;
      	break;
       default:
       		assert(0);
      }
    return;

};


int getFFCompressParams(COMPRESSION_MODE * mode, uint32_t * qz,
		      uint32_t * br,uint32_t *fsize,FFcodecSetting *conf)
{
    static GtkWidget *cprm;
    char *str;
    char string[100];
    uint32_t value;
    int ret = 0;
    //int firstTime=0;
    
    localconf=conf;
    	

    do
      {
	  compresslock = 0;
	  cprm = create_ffCompression();
	  //
	  switch (*mode)
	    {
	    	case COMPRESS_CBR:

			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON
						 (radiobutton2), 1);
			sprintf(string, "%d", (int) *br/1000);
			gtk_editable_insert_text(GTK_EDITABLE(entry_bitrate),
					 string, strlen(string), &ret);
			break;

		case COMPRESS_2PASS:
		    	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON
						 	(radiobutton3), 1);

			sprintf(string, "%d", (int) *fsize );
			gtk_editable_insert_text(GTK_EDITABLE(entry_size),
				 string, strlen(string), &ret);
			break;

	    	case COMPRESS_CQ:
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON
					     (radiobutton1), 1);

			sprintf(string, "%d", (int) *qz);
			gtk_editable_insert_text(GTK_EDITABLE(entry_qz),
					 string, strlen(string), &ret);
			break;
	  	default:
	  		assert(0);		
	    }
	 
	 set();
	 gtk_widget_show(cprm);
	  //__________________________________________________________
	  runDialog(&compresslock);
	  //__________________________________________________________
	  
	  if (1 == compresslock)
	    {
		// Get compression mode
		int r1;
		r1 = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON
						  (radiobutton1));
		r1 +=
		    2 *
		    gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON
						 (radiobutton2));
	r1 +=
		    4 *
		    gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON
						 (radiobutton3));
		printf("\n Mode: %d",r1);

		switch (r1)
		  {
		  case 2:
		      *mode = COMPRESS_CBR;
//ubr
		      str =
			  gtk_editable_get_chars(GTK_EDITABLE
						 (entry_bitrate), 0, -1);
		      value = (uint32_t) atoi(str);
		      if (value < 3000)
			  value *= 1000;
		      if (value > 16 && value < 6000000)
			{
			    *br = value;
			    ret = 1;
		      } else
			  ret = 0;
		      break;
		  case 1:
		      *mode = COMPRESS_CQ;
		      str =
			  gtk_editable_get_chars(GTK_EDITABLE(entry_qz), 0,
						 -1);
		      value = (uint32_t) atoi(str);
		      if (value >= 2 && value <= 32)
						{
			    			*qz = value;
			    			ret = 1;
		      	}
		      	else
						{
					printf("\n incorrect Q parameter\n");
				    ret = 0;
						}
		  	    break;
		  case 4:
		     *mode = COMPRESS_2PASS;
		       str=gtk_editable_get_chars(GTK_EDITABLE(entry_size), 0,
						 -1);
		      value = (uint32_t) atoi(str);
        		if((value>0)&&(value<2048))
          		{
       				*fsize=value;
				      	ret=1;
           	}
            	else
             		ret=0;
         		break;
		  default:
		      assert(0);
		  }



	    }
	    switch(compresslock)
	    {
	    	case -2:
			ret=1;
    			printf("\n destroyed ...\n");
			break;
	    	case 1:
			get(); // no break ! not an error !
		case -1:
		   	gtk_widget_destroy(cprm);
			break;
		default:assert(0);
	    }

      }
    while (!ret);		// end do
    printf("\n qz : %ld \n",*qz);
    printf("\n br : %ld \n",*br);
    printf("\n 2p : %ld \n",*fsize);
    if(compresslock==1) return 1;
    return 0;

}
 GtkWidget *create_ffCompression (void)
{
  GtkWidget *ffCompression;
  GtkWidget *dialog_vbox1;
  GtkWidget *notebook1;
  GtkWidget *vbox11;
  GtkWidget *label42;
  GtkWidget *vbox12;
  GtkWidget *hbox24;
  GtkWidget *label43;
  GtkWidget *vbox13;
  GtkWidget *hbox25;
  GSList *pp_compressmode_group = NULL;
//  GtkWidget *radiobutton1;
  GtkWidget *label44;
//  GtkWidget *entry_qz;
  GtkWidget *hbox26;
//  GtkWidget *radiobutton2;
  GtkWidget *label45;
//  GtkWidget *entry_bitrate;
  GtkWidget *hbox27;
//  GtkWidget *radiobutton3;
  GtkWidget *label46;
//  GtkWidget *entry_size;
  GtkWidget *hbox28;
  GtkWidget *hbox29;
  GtkWidget *label47;
  GtkWidget *label48;
  GtkWidget *label49;
  GtkWidget *hseparator10;
  GtkWidget *hbox30;
  //GtkWidget *optionmenu_quant;
  GtkWidget *optionmenu_quant_menu;
  GtkWidget *glade_menuitem;
  //GtkWidget *optionmenuME;
  GtkWidget *optionmenuME_menu;
//  GtkWidget *togglebutton_qpel;
//  GtkWidget *togglebutton_4mv;
//  GtkWidget *togglebutton_GMC;
//  GtkWidget *togglebutton_HQ;
  GtkWidget *hseparator12;
  GtkWidget *hseparator16;
  GtkWidget *hbox32;
  GtkWidget *label51;
  GtkObject *spinbutton_imin_adj;
//  GtkWidget *spinbutton_imin;
  GtkObject *spinbutton_imax_adj;
//  GtkWidget *spinbutton_imax;
  GtkWidget *hseparator20;
  GtkWidget *hseparator21;
//  GtkWidget *togglebutton_TREILLIS;
  GtkWidget *label39;
  GtkWidget *vbox14;
  GtkWidget *hbox38;
  GtkWidget *label61;
  GtkWidget *hbox40;
  GtkWidget *label62;
  GtkWidget *label63;
  GtkWidget *label64;
  GtkWidget *hbox39;
  GtkObject *spinbutton_startstart_adj;
//  GtkWidget *spinbutton_startstart;
  GtkObject *spinbutton_startend_adj;
//  GtkWidget *spinbutton_startend;
  GtkObject *spinbutton_cred_rate_adj;
//  GtkWidget *spinbutton_cred_rate;
  GtkWidget *label68;
  GtkWidget *hbox41;
  GtkWidget *label65;
  GtkWidget *label66;
  GtkWidget *hseparator18;
  GtkWidget *hbox42;
  GtkObject *spinbutton_endstart_adj;
//  GtkWidget *spinbutton_endstart;
  GtkObject *spinbutton_endend_adj;
//  GtkWidget *spinbutton_endend;
  GtkWidget *hseparator17;
  GtkWidget *label40;
  GtkWidget *vbox16;
  GtkWidget *hbox43;
  GtkWidget *hseparator25;
  GtkWidget *hseparator24;
  GtkWidget *table1;
  GtkObject *spinbutton_max_qdiff_adj;
//  GtkWidget *spinbutton_max_qdiff;
  GtkWidget *label75;
  GtkWidget *label76;
  GtkObject *spinbutton_qcompress_adj;
//  GtkWidget *spinbutton_qcompress;
  GtkWidget *label77;
  GtkObject *spinbutton_qblur_adj;
//  GtkWidget *spinbutton_qblur;
  GtkWidget *vbox17;
  GtkWidget *label78;
  GtkObject *spinbutton_lumi_masking_adj;
//  GtkWidget *spinbutton_lumi_masking;
  GtkWidget *label79;
  GtkObject *spinbutton_dark_masking_adj;
//  GtkWidget *spinbutton_dark_masking;
  GtkWidget *vbox18;
  GtkWidget *label80;
  GtkObject *spinbutton_luma_elim_threshold_adj;
//  GtkWidget *spinbutton_luma_elim_threshold;
  GtkWidget *label81;
  GtkObject *spinbutton_chroma_elim_threshold_adj;
//  GtkWidget *spinbutton_chroma_elim_threshold;
//  GtkWidget *togglebutton_bframe;
  GtkWidget *label74;
  GtkWidget *dialog_action_area1;
  GtkWidget *button9;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  ffCompression = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (ffCompression), "ffCompression", ffCompression);
  gtk_window_set_title (GTK_WINDOW (ffCompression), "FFmpeg compression");
  gtk_window_set_policy (GTK_WINDOW (ffCompression), TRUE, TRUE, FALSE);
  gtk_window_set_modal(GTK_WINDOW(ffCompression), 1);
  dialog_vbox1 = GTK_DIALOG (ffCompression)->vbox;
  gtk_object_set_data (GTK_OBJECT (ffCompression), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  notebook1 = gtk_notebook_new ();
  gtk_widget_ref (notebook1);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "notebook1", notebook1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (notebook1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), notebook1, TRUE, TRUE, 0);

  vbox11 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox11);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "vbox11", vbox11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox11);
  gtk_container_add (GTK_CONTAINER (notebook1), vbox11);

  label42 = gtk_label_new ("Compression Parameters");
  gtk_widget_ref (label42);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "label42", label42,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label42);
  gtk_box_pack_start (GTK_BOX (vbox11), label42, FALSE, FALSE, 0);

  vbox12 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox12);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "vbox12", vbox12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox12);
  gtk_box_pack_start (GTK_BOX (vbox11), vbox12, TRUE, TRUE, 0);

  hbox24 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox24);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "hbox24", hbox24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox24);
  gtk_box_pack_start (GTK_BOX (vbox12), hbox24, FALSE, FALSE, 0);

  label43 = gtk_label_new ("Mode:");
  gtk_widget_ref (label43);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "label43", label43,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label43);
  gtk_box_pack_start (GTK_BOX (hbox24), label43, FALSE, FALSE, 0);

  vbox13 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox13);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "vbox13", vbox13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox13);
  gtk_box_pack_start (GTK_BOX (hbox24), vbox13, TRUE, FALSE, 0);

  hbox25 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox25);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "hbox25", hbox25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox25);
  gtk_box_pack_start (GTK_BOX (vbox13), hbox25, FALSE, FALSE, 0);

  radiobutton1 = gtk_radio_button_new_with_label (pp_compressmode_group, "CQ");
  pp_compressmode_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton1));
  gtk_widget_ref (radiobutton1);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "radiobutton1", radiobutton1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton1);
  gtk_box_pack_start (GTK_BOX (hbox25), radiobutton1, TRUE, TRUE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton1), TRUE);

  label44 = gtk_label_new (", quality ");
  gtk_widget_ref (label44);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "label44", label44,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label44);
  gtk_box_pack_start (GTK_BOX (hbox25), label44, TRUE, TRUE, 0);
  gtk_widget_set_usize (label44, 100, -1);

  entry_qz = gtk_entry_new ();
  gtk_widget_ref (entry_qz);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "entry_qz", entry_qz,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_qz);
  gtk_box_pack_start (GTK_BOX (hbox25), entry_qz, TRUE, TRUE, 0);
  gtk_entry_set_text (GTK_ENTRY (entry_qz), "");

  hbox26 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox26);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "hbox26", hbox26,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox26);
  gtk_box_pack_start (GTK_BOX (vbox13), hbox26, FALSE, FALSE, 0);

  radiobutton2 = gtk_radio_button_new_with_label (pp_compressmode_group, "CBR");
  pp_compressmode_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton2));
  gtk_widget_ref (radiobutton2);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "radiobutton2", radiobutton2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton2);
  gtk_box_pack_start (GTK_BOX (hbox26), radiobutton2, TRUE, TRUE, 0);

  label45 = gtk_label_new (", bitrate");
  gtk_widget_ref (label45);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "label45", label45,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label45);
  gtk_box_pack_start (GTK_BOX (hbox26), label45, TRUE, TRUE, 0);
  gtk_widget_set_usize (label45, 100, -1);

  entry_bitrate = gtk_entry_new ();
  gtk_widget_ref (entry_bitrate);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "entry_bitrate", entry_bitrate,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_bitrate);
  gtk_box_pack_start (GTK_BOX (hbox26), entry_bitrate, TRUE, TRUE, 0);

  hbox27 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox27);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "hbox27", hbox27,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox27);
  gtk_box_pack_start (GTK_BOX (vbox13), hbox27, FALSE, FALSE, 0);

  radiobutton3 = gtk_radio_button_new_with_label (pp_compressmode_group, "2-Pass");
  pp_compressmode_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton3));
  gtk_widget_ref (radiobutton3);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "radiobutton3", radiobutton3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton3);
  gtk_box_pack_start (GTK_BOX (hbox27), radiobutton3, TRUE, TRUE, 0);

  label46 = gtk_label_new (", size in MB");
  gtk_widget_ref (label46);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "label46", label46,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label46);
  gtk_box_pack_start (GTK_BOX (hbox27), label46, TRUE, TRUE, 0);

  entry_size = gtk_entry_new ();
  gtk_widget_ref (entry_size);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "entry_size", entry_size,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_size);
  gtk_box_pack_start (GTK_BOX (hbox27), entry_size, TRUE, TRUE, 0);

  hbox28 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox28);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "hbox28", hbox28,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox28);
  gtk_box_pack_start (GTK_BOX (vbox12), hbox28, TRUE, TRUE, 0);
  gtk_widget_set_usize (hbox28, -1, 14);

  hbox29 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox29);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "hbox29", hbox29,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox29);
  gtk_box_pack_start (GTK_BOX (hbox28), hbox29, TRUE, TRUE, 0);

  label47 = gtk_label_new ("  Quantizer  ");
  gtk_widget_ref (label47);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "label47", label47,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label47);
  gtk_box_pack_start (GTK_BOX (hbox29), label47, FALSE, FALSE, 0);

  label48 = gtk_label_new ("  Motion Search");
  gtk_widget_ref (label48);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "label48", label48,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label48);
  gtk_box_pack_start (GTK_BOX (hbox29), label48, FALSE, FALSE, 0);

  label49 = gtk_label_new (" Extra Motion  ");
  gtk_widget_ref (label49);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "label49", label49,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label49);
  gtk_box_pack_start (GTK_BOX (hbox29), label49, FALSE, FALSE, 0);

  hseparator10 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator10);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "hseparator10", hseparator10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator10);
  gtk_box_pack_start (GTK_BOX (hbox29), hseparator10, FALSE, FALSE, 0);

  hbox30 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox30);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "hbox30", hbox30,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox30);
  gtk_box_pack_start (GTK_BOX (vbox12), hbox30, TRUE, TRUE, 0);

  optionmenu_quant = gtk_option_menu_new ();
  gtk_widget_ref (optionmenu_quant);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "optionmenu_quant", optionmenu_quant,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (optionmenu_quant);
  gtk_box_pack_start (GTK_BOX (hbox30), optionmenu_quant, FALSE, FALSE, 0);
  gtk_widget_set_usize (optionmenu_quant, -1, 14);
  gtk_tooltips_set_tip (tooltips, optionmenu_quant, "Quant ", NULL);
  optionmenu_quant_menu = gtk_menu_new ();
  
  glade_menuitem = gtk_menu_item_new_with_label ("H263");
  gtk_widget_show (glade_menuitem);  
  gtk_menu_append (GTK_MENU (optionmenu_quant_menu), glade_menuitem);
  
  
  glade_menuitem = gtk_menu_item_new_with_label ("Mpeg");
  gtk_widget_show (glade_menuitem);  
  gtk_menu_append (GTK_MENU (optionmenu_quant_menu), glade_menuitem);
  
  
  gtk_option_menu_set_menu (GTK_OPTION_MENU (optionmenu_quant), optionmenu_quant_menu);
  gtk_option_menu_set_history (GTK_OPTION_MENU (optionmenu_quant), 0);

  optionmenuME = gtk_option_menu_new ();
  gtk_widget_ref (optionmenuME);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "optionmenuME", optionmenuME,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (optionmenuME);
  gtk_box_pack_start (GTK_BOX (hbox30), optionmenuME, FALSE, FALSE, 0);
  gtk_widget_set_usize (optionmenuME, -1, 14);
  gtk_tooltips_set_tip (tooltips, optionmenuME, "Motion estimation", NULL);
  optionmenuME_menu = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label ("Zero");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenuME_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("Full");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenuME_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("Log");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenuME_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("PHODS");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenuME_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("EPZS");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenuME_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("X1");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenuME_menu), glade_menuitem);
  gtk_option_menu_set_menu (GTK_OPTION_MENU (optionmenuME), optionmenuME_menu);
  gtk_option_menu_set_history (GTK_OPTION_MENU (optionmenuME), 4);

  togglebutton_qpel = gtk_toggle_button_new_with_label ("Qpel");
  gtk_widget_ref (togglebutton_qpel);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "togglebutton_qpel", togglebutton_qpel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (togglebutton_qpel);
  gtk_box_pack_start (GTK_BOX (hbox30), togglebutton_qpel, TRUE, TRUE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (togglebutton_qpel), TRUE);

  togglebutton_4mv = gtk_toggle_button_new_with_label ("4mv");
  gtk_widget_ref (togglebutton_4mv);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "togglebutton_4mv", togglebutton_4mv,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (togglebutton_4mv);
  gtk_box_pack_start (GTK_BOX (hbox30), togglebutton_4mv, TRUE, TRUE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (togglebutton_4mv), TRUE);

  togglebutton_GMC = gtk_toggle_button_new_with_label ("GMC");
  gtk_widget_ref (togglebutton_GMC);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "togglebutton_GMC", togglebutton_GMC,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (togglebutton_GMC);
  gtk_box_pack_start (GTK_BOX (hbox30), togglebutton_GMC, TRUE, TRUE, 0);
  gtk_widget_set_usize (togglebutton_GMC, 60, -1);

  togglebutton_HQ = gtk_toggle_button_new_with_label ("HQ");
  gtk_widget_ref (togglebutton_HQ);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "togglebutton_HQ", togglebutton_HQ,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (togglebutton_HQ);
  gtk_box_pack_start (GTK_BOX (hbox30), togglebutton_HQ, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (togglebutton_HQ), TRUE);

  hseparator12 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator12);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "hseparator12", hseparator12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator12);
  gtk_box_pack_start (GTK_BOX (hbox30), hseparator12, FALSE, FALSE, 0);

  hseparator16 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator16);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "hseparator16", hseparator16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator16);
  gtk_box_pack_start (GTK_BOX (vbox11), hseparator16, FALSE, FALSE, 0);

  hbox32 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox32);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "hbox32", hbox32,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox32);
  gtk_box_pack_start (GTK_BOX (vbox11), hbox32, TRUE, TRUE, 0);

  label51 = gtk_label_new (" Q");
  gtk_widget_ref (label51);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "label51", label51,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label51);
  gtk_box_pack_start (GTK_BOX (hbox32), label51, FALSE, FALSE, 0);
  gtk_widget_set_usize (label51, 90, -1);

  spinbutton_imin_adj = gtk_adjustment_new (2, 2, 31, 1, 10, 10);
  spinbutton_imin = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_imin_adj), 1, 0);
  gtk_widget_ref (spinbutton_imin);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "spinbutton_imin", spinbutton_imin,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_imin);
  gtk_box_pack_start (GTK_BOX (hbox32), spinbutton_imin, TRUE, TRUE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_imin), TRUE);

  spinbutton_imax_adj = gtk_adjustment_new (31, 2, 31, 1, 10, 10);
  spinbutton_imax = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_imax_adj), 1, 0);
  gtk_widget_ref (spinbutton_imax);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "spinbutton_imax", spinbutton_imax,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_imax);
  gtk_box_pack_start (GTK_BOX (hbox32), spinbutton_imax, TRUE, TRUE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_imax), TRUE);

  hseparator20 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator20);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "hseparator20", hseparator20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator20);
  gtk_box_pack_start (GTK_BOX (hbox32), hseparator20, FALSE, FALSE, 0);

  hseparator21 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator21);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "hseparator21", hseparator21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator21);
  gtk_box_pack_start (GTK_BOX (hbox32), hseparator21, TRUE, TRUE, 0);

  togglebutton_TREILLIS = gtk_toggle_button_new_with_label ("Trellis Q");
  gtk_widget_ref (togglebutton_TREILLIS);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "togglebutton_TREILLIS", togglebutton_TREILLIS,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (togglebutton_TREILLIS);
  gtk_box_pack_start (GTK_BOX (hbox32), togglebutton_TREILLIS, FALSE, FALSE, 0);

  label39 = gtk_label_new ("General");
  gtk_widget_ref (label39);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "label39", label39,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label39);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 0), label39);

  vbox14 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox14);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "vbox14", vbox14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (notebook1), vbox14);
  gtk_widget_set_sensitive (vbox14, FALSE);

  hbox38 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox38);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "hbox38", hbox38,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox38);
  gtk_box_pack_start (GTK_BOX (vbox14), hbox38, TRUE, TRUE, 0);

  label61 = gtk_label_new ("---------------------- Start Credit--------------------");
  gtk_widget_ref (label61);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "label61", label61,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label61);
  gtk_box_pack_start (GTK_BOX (hbox38), label61, FALSE, FALSE, 0);
  gtk_label_set_line_wrap (GTK_LABEL (label61), TRUE);

  hbox40 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox40);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "hbox40", hbox40,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox40);
  gtk_box_pack_start (GTK_BOX (vbox14), hbox40, TRUE, TRUE, 0);

  label62 = gtk_label_new ("Start at frame");
  gtk_widget_ref (label62);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "label62", label62,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label62);
  gtk_box_pack_start (GTK_BOX (hbox40), label62, FALSE, FALSE, 0);
  gtk_widget_set_usize (label62, 120, -1);

  label63 = gtk_label_new ("End at frame");
  gtk_widget_ref (label63);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "label63", label63,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label63);
  gtk_box_pack_start (GTK_BOX (hbox40), label63, FALSE, FALSE, 0);
  gtk_widget_set_usize (label63, 120, -1);

  label64 = gtk_label_new ("% of quant:");
  gtk_widget_ref (label64);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "label64", label64,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label64);
  gtk_box_pack_start (GTK_BOX (hbox40), label64, FALSE, FALSE, 0);
  gtk_widget_set_usize (label64, 120, -1);

  hbox39 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox39);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "hbox39", hbox39,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox39);
  gtk_box_pack_start (GTK_BOX (vbox14), hbox39, TRUE, TRUE, 0);

  spinbutton_startstart_adj = gtk_adjustment_new (0, 0, 1e+08, 1, 10, 10);
  spinbutton_startstart = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_startstart_adj), 1, 0);
  gtk_widget_ref (spinbutton_startstart);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "spinbutton_startstart", spinbutton_startstart,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_box_pack_start (GTK_BOX (hbox39), spinbutton_startstart, TRUE, TRUE, 0);
  gtk_widget_set_sensitive (spinbutton_startstart, FALSE);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_startstart), TRUE);

  spinbutton_startend_adj = gtk_adjustment_new (0, 0, 1e+08, 1, 10, 10);
  spinbutton_startend = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_startend_adj), 1, 0);
  gtk_widget_ref (spinbutton_startend);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "spinbutton_startend", spinbutton_startend,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_startend);
  gtk_box_pack_start (GTK_BOX (hbox39), spinbutton_startend, TRUE, TRUE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_startend), TRUE);

  spinbutton_cred_rate_adj = gtk_adjustment_new (20, 0, 100, 1, 10, 10);
  spinbutton_cred_rate = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_cred_rate_adj), 1, 0);
  gtk_widget_ref (spinbutton_cred_rate);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "spinbutton_cred_rate", spinbutton_cred_rate,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_cred_rate);
  gtk_box_pack_start (GTK_BOX (hbox39), spinbutton_cred_rate, TRUE, TRUE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_cred_rate), TRUE);

  label68 = gtk_label_new ("---------------------- End Credit--------------------");
  gtk_widget_ref (label68);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "label68", label68,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label68);
  gtk_box_pack_start (GTK_BOX (vbox14), label68, FALSE, FALSE, 0);
  gtk_label_set_line_wrap (GTK_LABEL (label68), TRUE);

  hbox41 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox41);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "hbox41", hbox41,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox41);
  gtk_box_pack_start (GTK_BOX (vbox14), hbox41, TRUE, TRUE, 0);

  label65 = gtk_label_new ("Start at frame");
  gtk_widget_ref (label65);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "label65", label65,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label65);
  gtk_box_pack_start (GTK_BOX (hbox41), label65, FALSE, FALSE, 0);
  gtk_widget_set_usize (label65, 120, -1);

  label66 = gtk_label_new ("End at frame");
  gtk_widget_ref (label66);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "label66", label66,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label66);
  gtk_box_pack_start (GTK_BOX (hbox41), label66, FALSE, FALSE, 0);
  gtk_widget_set_usize (label66, 120, -1);

  hseparator18 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator18);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "hseparator18", hseparator18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator18);
  gtk_box_pack_start (GTK_BOX (hbox41), hseparator18, FALSE, FALSE, 0);

  hbox42 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox42);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "hbox42", hbox42,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox42);
  gtk_box_pack_start (GTK_BOX (vbox14), hbox42, TRUE, TRUE, 0);

  spinbutton_endstart_adj = gtk_adjustment_new (0, 0, 1e+08, 1, 10, 10);
  spinbutton_endstart = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_endstart_adj), 1, 0);
  gtk_widget_ref (spinbutton_endstart);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "spinbutton_endstart", spinbutton_endstart,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_endstart);
  gtk_box_pack_start (GTK_BOX (hbox42), spinbutton_endstart, TRUE, TRUE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_endstart), TRUE);

  spinbutton_endend_adj = gtk_adjustment_new (0, 0, 1e+08, 1, 10, 10);
  spinbutton_endend = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_endend_adj), 1, 0);
  gtk_widget_ref (spinbutton_endend);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "spinbutton_endend", spinbutton_endend,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_endend);
  gtk_box_pack_start (GTK_BOX (hbox42), spinbutton_endend, TRUE, TRUE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_endend), TRUE);

  hseparator17 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator17);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "hseparator17", hseparator17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator17);
  gtk_box_pack_start (GTK_BOX (hbox42), hseparator17, TRUE, TRUE, 0);

  label40 = gtk_label_new ("Credits");
  gtk_widget_ref (label40);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "label40", label40,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label40);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 1), label40);

  vbox16 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox16);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "vbox16", vbox16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox16);
  gtk_container_add (GTK_CONTAINER (notebook1), vbox16);

  hbox43 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox43);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "hbox43", hbox43,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox43);
  gtk_box_pack_start (GTK_BOX (vbox16), hbox43, FALSE, FALSE, 0);

  hseparator25 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator25);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "hseparator25", hseparator25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator25);
  gtk_box_pack_start (GTK_BOX (hbox43), hseparator25, FALSE, FALSE, 0);

  hseparator24 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator24);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "hseparator24", hseparator24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator24);
  gtk_box_pack_start (GTK_BOX (hbox43), hseparator24, TRUE, TRUE, 0);

  table1 = gtk_table_new (3, 3, FALSE);
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (vbox16), table1, TRUE, TRUE, 0);

  spinbutton_max_qdiff_adj = gtk_adjustment_new (3, 1, 31, 1, 10, 10);
  spinbutton_max_qdiff = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_max_qdiff_adj), 1, 0);
  gtk_widget_ref (spinbutton_max_qdiff);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "spinbutton_max_qdiff", spinbutton_max_qdiff,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_max_qdiff);
  gtk_table_attach (GTK_TABLE (table1), spinbutton_max_qdiff, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_max_qdiff), TRUE);

  label75 = gtk_label_new ("Max QDiff");
  gtk_widget_ref (label75);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "label75", label75,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label75);
  gtk_table_attach (GTK_TABLE (table1), label75, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label75), 0, 0.5);

  label76 = gtk_label_new ("QCompress");
  gtk_widget_ref (label76);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "label76", label76,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label76);
  gtk_table_attach (GTK_TABLE (table1), label76, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label76), 0, 0.5);

  spinbutton_qcompress_adj = gtk_adjustment_new (0.5, 0, 1, 0.1, 10, 10);
  spinbutton_qcompress = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_qcompress_adj), 1, 2);
  gtk_widget_ref (spinbutton_qcompress);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "spinbutton_qcompress", spinbutton_qcompress,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_qcompress);
  gtk_table_attach (GTK_TABLE (table1), spinbutton_qcompress, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_qcompress), TRUE);

  label77 = gtk_label_new ("Qblur");
  gtk_widget_ref (label77);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "label77", label77,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label77);
  gtk_table_attach (GTK_TABLE (table1), label77, 2, 3, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label77), 0, 0.5);

  spinbutton_qblur_adj = gtk_adjustment_new (0.5, 0, 1, 0.1, 10, 10);
  spinbutton_qblur = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_qblur_adj), 1, 1);
  gtk_widget_ref (spinbutton_qblur);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "spinbutton_qblur", spinbutton_qblur,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_qblur);
  gtk_table_attach (GTK_TABLE (table1), spinbutton_qblur, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_qblur), TRUE);

  vbox17 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox17);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "vbox17", vbox17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox17);
  gtk_table_attach (GTK_TABLE (table1), vbox17, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);

  label78 = gtk_label_new ("Lumi Masking ");
  gtk_widget_ref (label78);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "label78", label78,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label78);
  gtk_box_pack_start (GTK_BOX (vbox17), label78, FALSE, FALSE, 0);

  spinbutton_lumi_masking_adj = gtk_adjustment_new (0, -1, 1, 0.05, 10, 10);
  spinbutton_lumi_masking = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_lumi_masking_adj), 1, 2);
  gtk_widget_ref (spinbutton_lumi_masking);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "spinbutton_lumi_masking", spinbutton_lumi_masking,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_lumi_masking);
  gtk_box_pack_start (GTK_BOX (vbox17), spinbutton_lumi_masking, FALSE, FALSE, 0);

  label79 = gtk_label_new ("Dark Masking");
  gtk_widget_ref (label79);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "label79", label79,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label79);
  gtk_box_pack_start (GTK_BOX (vbox17), label79, FALSE, FALSE, 0);

  spinbutton_dark_masking_adj = gtk_adjustment_new (0, -1, 1, 0.01, 10, 10);
  spinbutton_dark_masking = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_dark_masking_adj), 1, 2);
  gtk_widget_ref (spinbutton_dark_masking);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "spinbutton_dark_masking", spinbutton_dark_masking,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_dark_masking);
  gtk_box_pack_start (GTK_BOX (vbox17), spinbutton_dark_masking, FALSE, FALSE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_dark_masking), TRUE);

  vbox18 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox18);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "vbox18", vbox18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox18);
  gtk_table_attach (GTK_TABLE (table1), vbox18, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  label80 = gtk_label_new ("Luma Elim Thresh");
  gtk_widget_ref (label80);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "label80", label80,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label80);
  gtk_box_pack_start (GTK_BOX (vbox18), label80, FALSE, FALSE, 0);

  spinbutton_luma_elim_threshold_adj = gtk_adjustment_new (0, -99, 99, 1, 10, 10);
  spinbutton_luma_elim_threshold = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_luma_elim_threshold_adj), 1, 0);
  gtk_widget_ref (spinbutton_luma_elim_threshold);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "spinbutton_luma_elim_threshold", spinbutton_luma_elim_threshold,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_luma_elim_threshold);
  gtk_box_pack_start (GTK_BOX (vbox18), spinbutton_luma_elim_threshold, FALSE, FALSE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_luma_elim_threshold), TRUE);

  label81 = gtk_label_new ("Chroma Elim Thresh");
  gtk_widget_ref (label81);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "label81", label81,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label81);
  gtk_box_pack_start (GTK_BOX (vbox18), label81, FALSE, FALSE, 0);

  spinbutton_chroma_elim_threshold_adj = gtk_adjustment_new (0, -99, 99, 1, 10, 10);
  spinbutton_chroma_elim_threshold = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_chroma_elim_threshold_adj), 1, 0);
  gtk_widget_ref (spinbutton_chroma_elim_threshold);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "spinbutton_chroma_elim_threshold", spinbutton_chroma_elim_threshold,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_chroma_elim_threshold);
  gtk_box_pack_start (GTK_BOX (vbox18), spinbutton_chroma_elim_threshold, FALSE, FALSE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_chroma_elim_threshold), TRUE);

  togglebutton_bframe = gtk_toggle_button_new_with_label ("B-Frame");
  gtk_widget_ref (togglebutton_bframe);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "togglebutton_bframe", togglebutton_bframe,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (togglebutton_bframe);
  gtk_table_attach (GTK_TABLE (table1), togglebutton_bframe, 2, 3, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  label74 = gtk_label_new ("Advanced Options");
  gtk_widget_ref (label74);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "label74", label74,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label74);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 2), label74);

  dialog_action_area1 = GTK_DIALOG (ffCompression)->action_area;
  gtk_object_set_data (GTK_OBJECT (ffCompression), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  button9 = gtk_button_new_with_label ("OK");
  gtk_widget_ref (button9);
  gtk_object_set_data_full (GTK_OBJECT (ffCompression), "button9", button9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button9);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), button9, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (button9), "clicked",
                      GTK_SIGNAL_FUNC (gui_ok),
                      (void *)1);

  gtk_object_set_data (GTK_OBJECT (ffCompression), "tooltips", tooltips);

  return ffCompression;
}



#endif

