/***************************************************************************
                          aviframe.cpp  -  description
                             -------------------
    begin                : Mon Nov 12 2001
    copyright            : (C) 2001 by mean
    email                : fixounet@free.fr

18/11/2001 : Began to optimize ( a bit) toward speed...

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>

#include <string.h>
//#include <sstream>
#include <assert.h>
#include <math.h>

#include "avifmt.h"
#include "avifmt2.h"
#include "avio.hxx"
#include "fourcc.h"
#include "riffparser.h"
#include "subchunk.h"


//________________________________________________________________
//      Go to a given frame
//________________________________________________________________
uint8_t aviHeader::setFlag(uint32_t frame, uint32_t flags)
{
  if (frame >= _nb_vchunk)
      {
	  printf("ooops too much chunks\n");
   	exit(0);
    }
   _videoindex[frame].Flags=flags;
    return 1;
}

uint8_t  aviHeader::getFrameSize(uint32_t frame,uint32_t *size)
{
	*size=0;
	   // oops ? Should never happen
    if (frame >= _nb_vchunk)
      {
		  printf("Oops out of scope %lu %lu \n",frame,_nb_vchunk);
   	  frame = _nb_vchunk - 1;
	   if( !_nb_vchunk) frame=0;
      return 0;
      }
    assert(frame < _nb_vchunk);
    if (size)
      {
	
	      *size = _videoindex[frame].Length;
      }
    return 1;

}

//______________________
// Go on any frame
//______________________
uint32_t aviHeader::getFlags(uint32_t frame, uint32_t * flags)
{


    // oops ? Should never happen
    if (frame >= _nb_vchunk)
      {
	  printf("ooops too much chunk %lu %lu \n",frame,_nb_vchunk);
   	  frame = _nb_vchunk - 1;
	   if( !_nb_vchunk) frame=0;
      return 0;
      }
    assert(frame < _nb_vchunk);
    _curframe = frame;
    if (flags)
      {
	
	      *flags = _videoindex[_curframe].Flags;
      }
    return 1;

}

uint8_t aviHeader::getFrameNoAlloc(uint32_t framenum, uint8_t * ptr,
				   uint32_t * framelen)
{
    return getFrameNoAlloc(framenum, ptr, framelen, 0);
}

uint8_t aviHeader::getFrameNoAlloc(uint32_t framenum, uint8_t * ptr,
				   uint32_t * framelen, uint32_t * flags)
{
    //          printf(" asked : %lu / current %lu\n",framenum,_curframe);

    if (framenum >= _nb_vchunk)
      {
	  printf("\n Wrong frame .. :%lu/%lu", framenum, _nb_vchunk);
	  return 0;
//                              assert(0);
      };
    _curframe = framenum;
    *framelen = _videoindex[_curframe].Length;
    if (flags)
	*flags = _videoindex[_curframe].Flags;
    _riff->goTo(_videoindex[_curframe].Offset);
    _riff->read(*framelen, ptr);
    return 1;
}


// EOF
