/***************************************************************************
                          avio.hxx  -  description
                             -------------------
    begin                : Thu Nov 1 2001
    copyright            : (C) 2001 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "ADM_editor/ADM_Video.h"
#include "avifmt.h"
#include "avifmt2.h"
#ifndef __AVIHEADER__
#define __AVIHEADER__

#include "subchunk.h"
#include "riffparser.h"
#include "avilist.h"
#include "ADM_audio/aviaudio.hxx"

// Allow null size frame
// That exists (really !) so let it !
#define ALLOW_ZERO
typedef int SAVEAVI_CB(int );

class riffparser;

#include "indexer.hxx"

class aviHeader     : public vidHeader
{
protected:
	
  	
		SubChunk			_videochunks;
		uint8_t 				_reordered;
	
    		uint32_t			_nb_vchunk;
		uint32_t			_maxvideo;
    		ShortIndex 			*_videoindex;
		
		
    		ShortIndex			*_audioindex;

		SubChunk			_audiochunks;
		uint32_t			_videostreaminfolen; //fixme
		uint32_t			_audiostreaminfolen; //fixme
		AVDMAviAudioStream   		*_avdm_stream;
    		uint32_t			_nb_achunk;
		uint32_t			_maxaudio;
    		uint32_t			_curframe;		
		riffparser 			*_riff;

		SubChunk			*last_vchunk;

		static 	uint8_t 			setStreamInfo(FILE *fo,
			uint8_t 			*stream,
			uint8_t 			*info,
			uint32_t 			infolen,
			uint32_t  maxxed);
		uint8_t				_audioStream;
		void 				deleteChain(SubChunk *first);

// Streams ....
	void 		attachVideo(AVIStreamHeader *vid,BITMAPINFOHEADER *bih,uint32_t len);
	void 		attachAudio(AVIStreamHeader *vid,void *bih,uint32_t len);
	uint8_t		reIndex(void);
	uint8_t		index(void);
	uint8_t   	brokenIndex(void);
  	uint8_t 	mergeIndex(uint32_t nbframe,SubChunk *First,
					ShortIndex **idx) ;
public:
//  static int checkFourCC(uint8_t *in, uint8_t *fourcc);

	
virtual   void 		Dump(void);
virtual   uint32_t 	getNbStream(void);
virtual   uint8_t 	needDecompress(void) { return 1;};
	 		aviHeader(void);	// clone
virtual	 		~aviHeader(){ };
// AVI io
virtual			uint8_t open(char *name) { return openAVI(name,0);}
virtual uint8_t 	close(void) { return closeAVI();}

 	uint8_t		openAVI(char *name,uint8_t rebuild_index=0);
   	uint8_t		openBrokenAVI(char *name);
 	uint8_t		closeAVI(void);
  //__________________________
  //				 Info
  //__________________________

  uint32_t		getWidth( void ) { return _mainaviheader.dwWidth;};
  uint32_t		getHeight( void ) { return _mainaviheader.dwHeight;};
  //__________________________
  //				 Audio
  //__________________________

virtual 	WAVHeader *getAudioInfo(void )  ;
virtual 	uint8_t	getAudioStream(AVDMGenericAudioStream **audio);

// Frames
  //__________________________
  //				 video
  //__________________________
virtual 	uint8_t  getFrameSize(uint32_t frame,uint32_t *size) ;

virtual 	uint8_t  setFlag(uint32_t frame,uint32_t flags);
virtual 	uint32_t getFlags(uint32_t frame,uint32_t *flags);			
virtual 	uint8_t  getFrameNoAlloc(uint32_t framenum,uint8_t *ptr,uint32_t* framelen,
												uint32_t *flags);
virtual 	uint8_t getFrameNoAlloc(uint32_t framenum,uint8_t *ptr,uint32_t* framelen);	
  		uint32_t getTime(uint32_t frame);

// index and stuff

//-----------------------------------------------
//   B -frame PTS / DTS logic
//----------------------------------------------
	uint8_t reorder( void );
	uint8_t			isReordered( void ) { return _reordered;} // by default we don"t do frame re-ordering
};
#endif
