/***************************************************************************
                          broken.cpp  -  description
                             -------------------
    begin                : Thu Jan 31 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>

#include <string.h>

#include <assert.h>
#include <math.h>

#include "avifmt.h"
#include "avifmt2.h"
#include "avio.hxx"
#include "fourcc.h"
#include "riffparser.h"
#include "subchunk.h"
#include "ADM_audio/aviaudio.hxx"
//______________________________________
//
//   Create riff parser, open avi and
//   collect stream information
//   Note that file is still opened at the end
//______________________________________
uint8_t aviHeader::openBrokenAVI(char *name)
{
    uint8_t *buffer,res;
    uint32_t len;
    uint8_t *buffer2;
    uint32_t len2;

    _riff = new riffparser;
    if (!_riff->openBroken(name))	// switch to alternate riff parser
      {
	  delete _riff;
	  _riff = NULL;
	  return 0;

      }
#ifdef DEBUG
    _riff->dumpChunks();
#endif

// Read Main Header chunk

    assert(_riff->
	   GetNextChunk((uint8_t *) "hdrl", (uint8_t *) "avih", &buffer,
			&len));
    assert(len == sizeof(MainAVIHeader));

    memcpy((char *) &_mainaviheader, (char *) buffer,
	   sizeof(MainAVIHeader));
    free(buffer);



    printf( "\n Main header read\n______________\n");

//_________________________
// Read first stream
//_________________________
// we assume there is at least one...
    printf( "\n Reading first stream information\n");

    assert(_riff->
	   GetNextChunk((uint8_t *) "strl", (uint8_t *) "strh", &buffer,
			&len));
    assert(_riff->
	   GetNextChunk((uint8_t *) "strl", (uint8_t *) "strf", &buffer2,
			&len2));


    attachVideo((AVIStreamHeader *) buffer, (BITMAPINFOHEADER *) buffer2,len2);
    free(buffer);
    free(buffer2);
//_________________________
// Read second stream (if exists)
//_________________________
    if (getNbStream() >= 2)
      {
	  printf( "\n Reading second stream information\n" );

	  assert(_riff->
		 GetNextChunk((uint8_t *) "strl", (uint8_t *) "strh",
			      &buffer, &len));
	  assert(_riff->
		 GetNextChunk((uint8_t *) "strl", (uint8_t *) "strf",
			      &buffer2, &len2));


	  attachAudio((AVIStreamHeader *) buffer, (void *) buffer2, len2);

	  free(buffer);
#warning FIXME
	  // free(buffer2);
      }
// if the flag has_index is NOT set force reindex
    printf( " Trying to rebuild index\n");

    brokenIndex();
	_avdm_stream = (AVDMAviAudioStream *) NULL;

    _riff->dumpChunks();

    _videostream.fccHandler = _video_bih.biCompression;


    printf("\n Merging index\n");


     res=mergeIndex(_nb_vchunk, _videochunks._next, &_videoindex);
    if(!res) return 0;
   res= mergeIndex(_nb_achunk, _audiochunks._next, &_audioindex);
    if(!res) return 0;
    if (_isaudiopresent)
      {
	  _avdm_stream = new AVDMAviAudioStream(_audioindex,
   						_nb_achunk,
						_riff,
						(WAVHeader *)
						_audiostreaminfo,
						//_audiostream.dwInitialFrames);
						0,0,NULL);

    }
	return 1;

}

//____________________
//
//_____________________
uint8_t aviHeader::brokenIndex(void)
{
    SubChunk *vchunk, *achunk;
    uint32_t asize = 0, vsize = 0, fcc, len;
    int32_t togo;

    // FIXME : I should try to understand
    // how to read the index chunk

    printf( " Attempting to Reindex broken AVI\n");

    vchunk = &_videochunks;
    achunk = &_audiochunks;
    _riff->rewindChunks();

    //assert(_riff->GoToPrimary((uint8_t *)"movi",&fcc));
    if (!_riff->
	GoToSecondary((uint8_t *) "movi", (uint8_t *) "dead",
		      (uint32_t *) & togo))
      {
	  printf ("***************************\n Sorry i can't handle that for now\n"
" and prefer to die rather than continue\n");
	  assert(0);

      }
    _nb_achunk = _nb_vchunk = 0;
       	togo=0x7fffffff;
    printf("\n Current position : %lx\n", _riff->getpos());
    printf("\n Bytes to scan : %lu\n", togo);


    do
      {
	  //printf("\nIndexing running, audio :%lu video : %lu found",
	  //              _nb_achunk,_nb_vchunk);

//#define __DEBUG
	  // should not be needed but there's a bug somewhere
	  //if((_riff->getpos()+8)>_length) goto endofindex2;
	  if (_riff->getRemaining() < 12)
	      goto endofindex2;
	  fcc = _riff->readu32();
	  len = _riff->readu32();
	  togo -= 8;
	  //if((_riff->getpos()+len)>_length) goto endofindex2;

#ifdef __DEBUG
	  printf("\n\t  pos : %lu (%lx) len : %lu (%lx) togo:%lu  FCC: ",
		 _riff->getpos(), _riff->getpos(), len, len, togo);
	  fourCC::print(fcc);

#endif


	  if (len & 1)
	      togo--;
	  if (!togo)
	      goto endofindex2;
	  if ((uint32_t)len >(uint32_t) _riff->getRemaining() )
	      goto endofindex2;
	  togo -= len;
	  if (fourCC::check(fcc, (uint8_t *) "01wb"))
	    {

		// audio
		achunk = achunk->append(_riff->getpos(), len, 0);
		_riff->forward(len);

		_nb_achunk++;
		asize += len;
		if (len > _maxaudio)
		    _maxaudio = len;
	  } else
	    {
		if ((fourCC::check(fcc, (uint8_t *) "00dc"))
		    || (fourCC::check(fcc, (uint8_t *) "00db")))
		  {		// nope, it is a video one
		      if (fourCC::check(fcc, (uint8_t *) "00db"))
			  vchunk =
			      vchunk->append(_riff->getpos(), len,
					     AVI_KEY_FRAME);
		      else
			  vchunk = vchunk->append(_riff->getpos(), len, 0);

		      vsize += len;
		      _riff->forward(len);
		      _nb_vchunk++;
		      if (len > _maxvideo)
			  _maxvideo = len;
		} else
		  {
		      // stop when a non-a/v chunk is found
		      // we got them all ?

		      goto endofindex2;
		  }
	    }


      }
    while (_riff->getRemaining()>1024);
  endofindex2:
    printf("\nIndexing done, audio  :%lu video  : %lu found",
	   _nb_achunk, _nb_vchunk);
    printf("\n               ausize :%lu vdsize : %lu found\n",
	   asize, vsize);

    // update info
    printf("\n Upgrading nb frames from : %lu to %lu\n",
	   _mainaviheader.dwTotalFrames, _nb_vchunk);
    // set video size
    _mainaviheader.dwTotalFrames = _nb_vchunk - 1;
    // and audio size
    // if audio size is null, remove audio
    _audiostream.dwLength = asize;
    if (asize == 0)
	_isaudiopresent = 0;
    // finally check for missing FCC (mencoder)


    return 1;


}

//
