/***************************************************************************
                          riffparser.cpp  -  description
                             -------------------
    begin                : Thu Nov 1 2001
    copyright            : (C) 2001 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <stdio.h>
#ifdef HAVE_SYS_PARAM_H
#include <sys/param.h>
#endif
#ifdef __FreeBSD__
          #include <sys/types.h>
#endif
//#include <stream.h>
#include <stdlib.h>
#include <assert.h>
#include <config.h>
#include "avifmt.h"
#include "avifmt2.h"
#include "subchunk.h"
#include "avio.hxx"
#include "riffparser.h"
#include "fourcc.h"
#include "ADM_toolkit/toolkit.hxx"

#define aprintf printf
riffparser::riffparser()
{
}

//________________________________________
uint8_t riffparser::open(char *filename)
{
    uint32_t l;
    uint32_t rd,prim;

    _current_list = 0;
    _curpos = 0;
    _list_max = 0;
    _file = fopen(filename, "rb");
    if (!_file)
	return 0;
    rd=readu32();
    if (!fourCC::check(rd, (uint8_t *) "RIFF"))
	{
	printf("!RIFF\n");
	for(int i=0;i<4;i++)
	printf(" ++  %x\n",*(_buffer+i));
	return 0;
	}
    _length =readu32(); 
    rd=readu32();
    if (!fourCC::check(rd, (uint8_t *) "AVI "))
	{

	printf("!AVI\n");
	return 0;
	}
    printf(" AVI file %s opened\n Filesize : %lu ",filename,_length);
    printf("(0x%lx)\n", _length);

    // construct list index
    while (_curpos < _length)
      {

	  rd=readu32();
	  switch(rd)
	    {
		case 'KUNJ':
			l=readu32();
		forward(l);
			break;
		case 'TSIL':
			l=readu32();
		      prim=_list[_list_max].fourcc_prim =readu32();
		      _list[_list_max].fourcc_sec =readu32();
		      _list[_list_max].size = readu32();
		      _list[_list_max].offset = _curpos;

#ifdef DEBUG_L2
		      printf
			  ("\n LIST at : %08lx size: %ld (0x%lx), next :%ld (%lx)",
			   _curpos, l, l, l + _curpos - 4,
			   l + _curpos - 4);
		      fourCC::print(_list[_list_max].fourcc_prim);
		      fourCC::print(_list[_list_max].fourcc_sec);

#endif
		      // First movie chunk ?
		      if (fourCC:: check(prim, (uint8_t *) "movi"))
			{
			    // Try to grab index chunk
			    forward(l - 12);
			    rd=readu32();
			    // go to idx field
			    if (!fourCC:: check(rd, (uint8_t *) "idx1"))
			      {

					printf("\n ****************\n Expecting index found :");
				  fourCC::print(rd);
				printf("\nTrying to continue anyway...\n");
				  // in that case, the chunk goes to the first movie index
				  // we will rebuild the real index later
				  _list[_list_max].fourcc_prim = fourCC::get((uint8_t *) "movi");
				  _list[_list_max].fourcc_sec = fourCC::get((uint8_t *) "dead");
				  _list[_list_max].size = l;
				  _list[_list_max].offset = _curpos + 8 - l;
				  _list_max++;
				  goto done1;

			      }
			    l=readu32();
			    _list_max++;
			    _list[_list_max].fourcc_prim =
				fourCC::get((uint8_t *) "movi");
			    _list[_list_max].fourcc_sec =
				fourCC::get((uint8_t *) "idx1");;
			    _list[_list_max].size = l;
			    _list[_list_max].offset = _curpos;
			    _list_max++;
			    printf("\n Got them all... skipping...\n");
			    goto done1;
		      } else
			{
			    forward(_list[_list_max].size);
				aprintf("chunk size2 : %lu\n",_list[_list_max].size);

			}
			break;

		default:
		      prim=_list[_list_max].fourcc_prim = _list[_list_max - 1].fourcc_prim;
		      _list[_list_max].fourcc_sec =rd;
		      _list[_list_max].size = readu32();
		      _list[_list_max].offset = _curpos;
		      forward(_list[_list_max].size);
		      aprintf("chunk size : %lu\n",_list[_list_max].size);

		      //printf("\n CHUNK");   


		      if (fourCC::
			  check(prim, (uint8_t *) "movi"))
			{
			    assert(0);	// should never get here                                                     

			}

		  }


		printf("\n at: 0x%08lx ", _list[_list_max].offset);
		fourCC::print(_list[_list_max].fourcc_prim);
		fourCC::print(_list[_list_max].fourcc_sec);
		printf(" size : %ld", _list[_list_max].size);
		_list_max++;
		assert(_list_max < MAX_LIST);
	    }
  done1:

    // we now try to get the idx1 chunk
    // or fast climbing the whole file
    // not sure what to do
    aprintf("\n curspos : %ld (0x%lx)\n", _curpos, _curpos);
    if (_list_max < 3)
      {
	  printf("\n *** NOT ENOUGH CHUNKS FOUND ***\n *** POSSIBLE ZERO-BYTE FILE ***\n *** Did you attempt to overwrite the input file by mistake? ***\n" );
	  return (0);

      }
    dumpChunks();
    return 1;
}

//____________________________________________  
void riffparser::rewindChunks(void)
{
    _current_list = 0;
};

//
//riffparser::getChunk(long
//
//riffparser::getChunk(long
//________________________________
void riffparser::dumpChunks(void)
{
    for (int i = 0; i < _list_max; i++)
      {
	  printf("\n Offset : %08lx, size : %08lx  fcc:", _list[i].offset,
		 _list[i].size);
	  fourCC::print(_list[i].fourcc_prim);
	  fourCC::print(_list[i].fourcc_sec);
      };

}

//________________________________________________
//________________________________________________
uint8_t riffparser::GoToPrimary(uint8_t * fcc_prim, uint32_t * second)
{
    uint8_t found = 0;

    assert(_current_list < _list_max);
    do
      {
	  if (fourCC::check(_list[_current_list].fourcc_prim, fcc_prim))
	    {
		found = 1;
		goto ex_seek1;	// ugly but faster & simpler
	    }
	  _current_list++;
      }
    while (_current_list < _list_max);

  ex_seek1:
    if (found == 0)
	return 0;

    rewind();
    forward(_list[_current_list].offset - 8);

    *second = _list[_current_list].fourcc_sec;

    _current_list++;		// go to next chunk

    return 1;


}

//
uint8_t riffparser::GoToSecondary(uint8_t * fcc_prim, uint8_t * second,
				  uint32_t * len)
{
    uint8_t found = 0;

    if (_current_list >= _list_max)
      {
	  printf( "*** WARNING CHUNK NOT FOUND *** %s", fcc_prim );
	  return 0;
      }
    do
      {
	  if (fourCC::check(_list[_current_list].fourcc_prim, fcc_prim)
	      && fourCC::check(_list[_current_list].fourcc_sec, second))
	    {
		found = 1;
		goto ex_seek1;	// ugly but faster & simpler
	    }
	  _current_list++;
      }
    while (_current_list < _list_max);

  ex_seek1:
    if (found == 0)
	return 0;

    rewind();
    forward(_list[_current_list].offset);

    *len = _list[_current_list].size;

    _current_list++;		// go to next chunk

    return 1;


}

//_______________________________
uint8_t riffparser::GetNextChunk(uint8_t * fcc, uint8_t * fcc2,
				 uint8_t ** buffer, uint32_t * size)
{
    uint8_t *lptr;
    uint32_t lsize;
    uint8_t found = 0;

    assert(_current_list < _list_max);
    do
      {
	  if (fourCC::check(_list[_current_list].fourcc_prim, fcc) &&
	      fourCC::check(_list[_current_list].fourcc_sec, fcc2))
	    {
		found = 1;
		goto ex_seek;	// ugly but faster & simpler
	    }
	  _current_list++;
      }
    while (_current_list < _list_max);

  ex_seek:
    if (found == 0)
	return 0;

    lsize = _list[_current_list].size;

    lptr = (uint8_t *) malloc(lsize);
    assert(lptr);

    rewind();
    forward(_list[_current_list].offset);

    read(lsize, lptr);

    *buffer = lptr;
    *size = lsize;

    _current_list++;		// go to next chunk

    return 1;

}

//________________________________
riffparser::~riffparser()
{
    fclose(_file);

}

//______________________________
uint32_t riffparser::readu32(void)
{
    uint8_t buf[5];
    uint32_t val;

    if ((fread(buf, 4, 1, _file) != 1))
      {
	  printf("\n Fatal error at post:%lu trying to get 4 bytes",
		 _curpos);

	GUI_Alert((char *)"Problem reading AVI\n Index broken!");
	  assert(0);
      }
    _curpos += 4;
    val=buf[0]+(buf[1]<<8)+(buf[2]<<16)+(buf[3]<<24);
    return  val;
}

//_________________________________
uint32_t riffparser::read(uint32_t nb)
{
#ifdef ALLOW_ZERO
    if (nb == 0)
	return 0;
#endif
    if(fread(_buffer, nb, 1, _file) != 1)
			{
            	GUI_Alert((char *)"Problem reading AVI\n Index broken!");
				assert(0);
			}
    _curpos += nb;
    //printf("\n read ---> curpos by %ld (%lx )",_curpos,_curpos);

    return nb;
}

//_________________________________
uint32_t riffparser::read(uint32_t nb, uint8_t * ptr)
{
#ifdef ALLOW_ZERO
    if (nb == 0)
	return 0;
#endif
    if(fread(ptr, nb, 1, _file) != 1)
			{
            	GUI_Alert((char *)"Problem reading AVI\n Index broken!");
				assert(0);
			}

    _curpos += nb;
    //printf("\n read ---> curpos by %ld (%lx )",_curpos,_curpos);
    return nb;
}

//______________________________________
void riffparser::rewind(void)
{
#ifdef NO_LARGE_FILE
	fseek(_file,0,SEEK_SET);
#else
    fseeko(_file, (off_t)0, SEEK_SET);
#endif
    _curpos = 0;

}

//______________________________________
uint32_t riffparser::forwardbyte(uint32_t nb)
{


    //printf("\n  ---> Forwarding by %ld (%lx )",nb,nb);
#ifdef NO_LARGE_FILE
    fseek(_file, (off_t)nb, SEEK_CUR);
#else
    fseeko(_file, (off_t)nb, SEEK_CUR);
#endif

    _curpos += nb;
    //printf("\n  ---> curpos by %ld (%lx )",_curpos,_curpos);

    return _curpos;
}

uint32_t riffparser::forward(uint32_t nb)
{

    nb = (nb + 1) & ~1;
    //printf("\n  ---> Forwarding by %ld (%lx )",nb,nb);
#ifdef NO_LARGE_FILE
		    fseek(_file, nb, SEEK_CUR);
#else
		    fseeko(_file, (off_t)nb, SEEK_CUR);
#endif

    _curpos += nb;
    //printf("\n  ---> curpos by %ld (%lx )",_curpos,_curpos);

    return _curpos;
}

//______________________________________
uint32_t riffparser::goTo(uint32_t abs)
{

    abs = (abs + 1) & ~1L;
#ifdef NO_LARGE_FILE
		    fseek(_file, (off_t)abs, SEEK_SET);
#else
		    fseeko(_file, (off_t)abs, SEEK_SET);
#endif

    _curpos = abs;

    //}

    return _curpos;
}


//
// open in broken mode
// The rest will be done by aviio
//________________________________________
uint8_t riffparser::openBroken(char *filename)
{
    uint32_t l, rd;

    _current_list = 0;
    _curpos = 0;
    _list_max = 0;
    _file = fopen(filename, "rb");
// Don't trust the size...
    if (!_file)
	return 0;
#ifdef NO_LARGE_FILE
    fseek(_file, 0, SEEK_END);
    _length = (uint32_t)ftell(_file);
    fseek(_file, 0, SEEK_SET);
#else
    fseeko(_file, (off_t)0, SEEK_END);
    _length = (uint32_t)ftello(_file);
    fseeko(_file, (off_t)0, SEEK_SET);
#endif


    printf("\n Opening in suspicious mode\n");;

    read(12);
    if (!fourCC::check((uint8_t *) _buffer, (uint8_t *) "RIFF"))
	return 0;
    if (!fourCC::check(8 + (uint8_t *) _buffer, (uint8_t *) "AVI "))
	return 0;

    printf(" AVI file %s opened, Filesize : %lu", filename,_length);
    printf("(0x%lx)\n", _length);

    // construct list index

    while (_curpos < _length)
      {

	  read(4);

	  // we can safely (?) assume that there is not 2 junks in a raw
	  if (fourCC::check((uint8_t *) _buffer, (uint8_t *) "JUNK"))
	    {
		read(4);
		//printf("\nJunk\n");

		l = *(uint32_t *) (_buffer);
		forward(l);
		//printf("\n Forwarding :%lx\n",l);             

	  } else
	    {			//____________list____________
		if (fourCC::check((uint8_t *) _buffer, (uint8_t *) "LIST"))
		  {		// new list
		      read(16);	// Was 16 ?
		      _list[_list_max].fourcc_prim = R32(*(uint32_t *) (_buffer + 4));
		      _list[_list_max].fourcc_sec = R32(*(uint32_t *) (_buffer + 8));
		      _list[_list_max].size = R32(*(uint32_t *) (_buffer + 12));
		      _list[_list_max].offset = _curpos;

		      l = *(uint32_t *) (_buffer);
#if 1
		      printf
			  ("\n LIST at : %08lx size: %ld (0x%lx), next :%ld (%lx)",
			   _curpos, l, l, l + _curpos - 4,
			   l + _curpos - 4);
		      fourCC::print(_list[_list_max].fourcc_prim);
		      fourCC::print(_list[_list_max].fourcc_sec);

#endif
		      // First movie chunk ?
		      if (fourCC::
			  check((uint8_t *) & _list[_list_max].fourcc_prim,
				(uint8_t *) "movi"))
			{
			    // Go movie chunk, stop here
			    // In the case of movie chunk
			    // the structure is LIST size MOVIE subchunk
			    // so we took 4 extra bytes from subchunk

			    // in that case, the chunk goes to the first movie index
			    // we will rebuild the real index later
			    _list[_list_max].size = l;
			    _list[_list_max].fourcc_prim = fourCC::get((uint8_t *) "movi");
			    _list[_list_max].fourcc_sec = fourCC::get((uint8_t *) "dead");;
			    // We take the smallest one between the size indicated  
			    // and the size we found
			    rd = _length - _curpos;	// +8 ?
			    printf
				("\n position %lu // total: %lu\n // indicated size : %lu",
				 _curpos, _length, _list[_list_max].size);
			    if (rd < _list[_list_max].size)
			      {
				  printf
				      ("\n changing movie size from %lu to %lu\n",
				       _list[_list_max].size, rd);
				  _list[_list_max].size = rd;
			      }
			    _list[_list_max].offset = _curpos - 8;
			    _list_max++;
			    goto done2;

		      } else
			{
			    forward(_list[_list_max].size);
			}
		} else		// subchunk
		  {

		      _list[_list_max].fourcc_prim = _list[_list_max - 1].fourcc_prim;
		      _list[_list_max].fourcc_sec = R32(*(uint32_t *) (_buffer));
		      read(4);
		      _list[_list_max].size = R32(*(uint32_t *) (_buffer));
		      _list[_list_max].offset = _curpos;
		      forward(_list[_list_max].size);
		      //printf("\n CHUNK");   


		      if (fourCC::
			  check((uint8_t *) & _list[_list_max].fourcc_prim,
				(uint8_t *) "movi"))
			{
			    assert(0);	// should never get here                                                     
			}

		  }


		printf("\n at: 0x%08lx ", _list[_list_max].offset);
		fourCC::print(_list[_list_max].fourcc_prim);
		fourCC::print(_list[_list_max].fourcc_sec);
		printf(" size : %ld", _list[_list_max].size);
		_list_max++;
		assert(_list_max < MAX_LIST);
	    }


      };
  done2:

    // we now try to get the idx1 chunk
    // or fast climbing the whole file
    // not sure what to do
#ifdef DEBUG
    printf("\n curspos : %ld (0x%lx)\n", _curpos, _curpos);
#endif
    if (_list_max < 3)
      {
	  printf( " *** NOT ENOUGH CHUNKS FOUND ***\n *** Did you attempt to overwrite the input file by mistake? ***\n");
	  assert(0);

      }
	printf("\n Successfully opened AVI\n");
    return 1;
}

// EOF       fseek      ftell
